qq_plotb <- function(pvals,conflev=0.9,twosided=TRUE,titlename=titlename) {

#   Generates Q-Q plot.
#   CODES NEDEED: qunif_order
#
#   author: Jozsef Bukszar 
#           jbukszar@vcu.edu
#

    len <- length(pvals)

    maxi <- len*0.01
 
    v <- (1:len)/(len+1)

    sort_pvals<-sort(pvals)

    logv <- -log10(v)
    logpvals <- -log10(sort_pvals)


    if (twosided) gamma <- (1 - conflev)*0.5
      else gamma <- 1 - conflev
    upw <- v
    upw[1] = qunif_order(gamma,1,len,inte=c(0,1))
    i<-1
    while (i<maxi) {
        i =  i + 1
        upw[i] = qunif_order(gamma,i,len,inte=c(upw[i-1],1))
    }
print(i)

    logupw <- -log10(upw)

    maxkarol <- max(logupw[1], logpvals[1] )

    plot(c(logv[1],logv[len],logv[1],logv[len]),c(logpvals[len],logpvals[len],maxkarol,maxkarol),cex=0.1,type="n",xlab="Expected (-logP)", ylab="Observed (-logP)",main=titlename)
    points(logv,logpvals)
    points(logv,logupw,type="l",col=4)


    if (twosided) {
       delta <- 0.5*(1+conflev)
       low <- v
       low[1] = qunif_order(delta,1,len,inte=c(0,1))
       i<-1
       while (i<maxi) {
           i =  i + 1
           low[i] = qunif_order(delta,i,len,inte=c(low[i-1],1))
       }
print(i)

      loglow <- -log10(low)
      points(logv,loglow,type="l",col=4)





    }


    points(c(logv[1],logv[len]),c(logv[1],logv[len]),col=2,type="l")

#   Calculating lambda:
	
    xx <- qchisq(1-pvals,1)
	
    lambda <- median(xx)/0.455
	
    print( " The estimate of lambda is " )
    print(lambda)
	
    lambda
	
    text(2,0.5,paste("lambda = ", round(lambda,digits=3), sep=""))  # modified from 4 to 2.
		 
		 
	
}

##############


qunif_order <- function(prob,k,n,inte=c(0,1)) {

#  Calculates the quantile function value of the kth member of sorted i.i.d. p-values following (0,1) uniform distribution.
#
#    INPUTS
# 
#      prob : point at which the quantile value will be calculated
#         k : kth member of the sorted i.i.d. that will be calculated
#         n : the total number of p-values sorted
#
 
     fugg <- function(x) {
        val <- 1-pbinom(k-1,n,x) - prob
     }


     xmin <- uniroot(fugg, inte,tol=1e-30)


     xmin$root

}

